/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Presentation;

import FunctionLayer.MapBoard;
import FunctionLayer.ErrorMessageDisplay;
import FunctionLayer.LogicFacade;
import FunctionLayer.UserBanners;
import FunctionLayer.Users;
import java.beans.PropertyVetoException;
import java.io.IOException;
import java.sql.SQLException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

/**
 *
 * @author install1
 */
public class DisplayContent extends Command {

    @Override
    String execute(HttpServletRequest request, HttpServletResponse response) throws ErrorMessageDisplay {
        try {
            HttpSession session = request.getSession();
            List<Users> PlayerLeaderBoard = (List<Users>) session.getAttribute("LeaderBoard");
            List<MapBoard> mapBoard = (List<MapBoard>) session.getAttribute("MapBoard");
            boolean firsttime = session.getAttribute("first") != null;
            PlayerLeaderBoard = LogicFacade.GetAllUsersNameSteamIdAvatar(PlayerLeaderBoard);
            List<Users> UpdateDBAvatars = PlayerLeaderBoard;
            List<UserBanners> UB = (List<UserBanners>) session.getAttribute("UserBanners");;
            if (mapBoard == null) {
                mapBoard = LogicFacade.GetAllMapColoumns();
            }
            PlayerLeaderBoard = LogicFacade.getPlayerPointsAndRank(PlayerLeaderBoard, mapBoard, firsttime);
            mapBoard = LogicFacade.getAllMapValues(mapBoard, PlayerLeaderBoard);
            if (UB == null) {
                UB = LogicFacade.getUserBanners(PlayerLeaderBoard);
            }
            PlayerLeaderBoard = LogicFacade.getPlayertimeAmount(PlayerLeaderBoard, mapBoard);
            if (mapBoard.size() < 1) {
                throw new ErrorMessageDisplay("No maps available, call jenz mapBoard size: " + mapBoard.size() + " other: " + mapBoard.get(0).getMapvalues().size());
            }
            session.setAttribute("first", firsttime);
            session.setAttribute("LeaderBoard", PlayerLeaderBoard);
            session.setAttribute("MapBoard", mapBoard);
            session.setAttribute("UserBanners", UB);
            Thread t = new Thread() {
                @Override
                public void run() {
                    while (true) {
                        try {
                            LogicFacade.UpdatePlayerAvatarsToDB(UpdateDBAvatars);
                            Thread.sleep(1000 * 60 * 180);
                        } catch (IOException | InterruptedException | ErrorMessageDisplay ex) {
                            Logger.getLogger(DisplayContent.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                }
            };
            t.start();
        } catch (SQLException | IOException | PropertyVetoException ex) {
            Logger.getLogger(DisplayContent.class.getName()).log(Level.SEVERE, null, ex);
        }
        return "Content";
    }

}
